
/* 
Скетч собран из декодера морзе CW Decoder made by Hjalmar Skovholm Hansen OZ1JHM
И CW маячка https://github.com/NicoVarg99/Arduino-CW-beacon/blob/master/beacon.ino
плюс мой парсер команд и программа контроля напряжения батареи
пины: А0 - вход декодера морзянки, на него подать через делитель половину опорного напряжения и через конденсатор подключить к выходу радиоприемника
А1 - напряжение батареи через делитель напряжения
А2 - напряжение солнечной батареи (ну или блока питания, маяк контролирует напряжение резервного аккумулятора и
умеет отключать заряд и отменять передачу при отсутствии напряжения с солнечной и разряде аккума ниже критического,
напряжения нужно установить вручную в строке 189, а также выставить коэффициенты делителя и опору ацп, в формуле там все есть
А3 - диод-термодатчик катод к пину А3, анод на землю
пин D1-включение заряда батареи (высокий уровень включает заряд)
D13 - выход CW манипулятора и индикатора CW приема, объединены для удобства отладки
Можете установить любую другую ногу для передачи CW в функциях dash() dot() в строках 446-460
команды на которые будет отвечать маяк и функции для их выполнения находятся в функции parse() на странице 582


*/
//дефайны для функций отправки морзянки
#define SPEED (10)  //скорость передачи, слов в минуту
#define DOTLEN (1200/SPEED)
#define DASHLEN (3*(1200/SPEED))
#define PAUSE (180000)  //pause between transmissions in milliseconds (not used in this project
#define CARRIER (10000)  // unmodulated carrier length symbol $

////////////////////////////////
// Define 8 specials letters  //
////////////////////////////////

/*byte U_umlaut[8] =   {B01010,B00000,B10001,B10001,B10001,B10001,B01110,B00000}; // '�'
  byte O_umlaut[8] =   {B01010,B00000,B01110,B10001,B10001,B10001,B01110,B00000}; // '�'
  byte A_umlaut[8] =   {B01010,B00000,B01110,B10001,B11111,B10001,B10001,B00000}; // '�'
  byte AE_capital[8] = {B01111,B10100,B10100,B11110,B10100,B10100,B10111,B00000}; // '�'
  byte OE_capital[8] = {B00001,B01110,B10011,B10101,B11001,B01110,B10000,B00000}; // '�'
  byte fullblock[8] =  {B11111,B11111,B11111,B11111,B11111,B11111,B11111,B11111};
  byte AA_capital[8] = {B00100,B00000,B01110,B10001,B11111,B10001,B10001,B00000}; // '�'
  byte emtyblock[8] =  {B00000,B00000,B00000,B00000,B00000,B00000,B00000,B00000};
*/
int audioInPin = A0;
int batPin = A1;
int solPin = A2;
int tmpPin = A3;
int ledPin = 13;
int chargePin = 1; //battery charging control pin
//дефайны отправки морзянки и контроля заряда
int adcbat = 0;
int adcsol = 0;
int adcemi = 0;
void sendMsg(char*);
void dash();
void dot();
void parse(char*);
const int in = tmpPin;          //  temperature sensor diode pin
const int t0 = 20.5;        // temperature calibration point, measure the temperature and write in this constant
const float vf0 = 567;   // and measure voltage on diode and write in this constant
// variables
int i;
float dtemp, dtemp_avg, tmp, sol, bat, emi;

//-------------------------------------------------------------------------

float magnitude ;
int magnitudelimit = 100;
int magnitudelimit_low = 100;
int realstate = LOW;
int realstatebefore = LOW;
int filteredstate = LOW;
int filteredstatebefore = LOW;

String strData = "";
///////////////////////////////////////////////////////////
// The sampling frq will be 8928 on a 16 mhz             //
// without any prescaler etc                             //
// because we need the tone in the center of the bins    //
// you can set the tone to 496, 558, 744 or 992          //
// then n the number of samples which give the bandwidth //
// can be (8928 / tone) * 1 or 2 or 3 or 4 etc           //
// init is 8928/558 = 16 *4 = 64 samples                 //
// try to take n = 96 or 128 ;o)                         //
// 48 will give you a bandwidth around 186 hz            //
// 64 will give you a bandwidth around 140 hz            //
// 96 will give you a bandwidth around 94 hz             //
// 128 will give you a bandwidth around 70 hz            //
// BUT remember that high n take a lot of time           //
// so you have to find the compromice - i use 48         //
///////////////////////////////////////////////////////////

float coeff;
float Q1 = 0;
float Q2 = 0;
float sine;
float cosine;
float sampling_freq = 8928.0;
float target_freq = 558.0; /// adjust for your needs see above
float n = 48.0; //// if you change  her please change next line also
int testData[48];

//////////////////////////////
// Noise Blanker time which //
// shall be computed so     //
// this is initial          //
//////////////////////////////
int nbtime = 6;  /// ms noise blanker

long starttimehigh;
long highduration;
long lasthighduration;
long hightimesavg;
long lowtimesavg;
long startttimelow;
long lowduration;
long laststarttime = 0;

char code[20];
int stop = LOW;
int wpm;
uint32_t myTimer1; //переменная таймера периода маяка

////////////////
// init setup //
////////////////
void setup() {
  //-------------------------------------------------------------------
  //сетап передающей части
  pinMode(ledPin, OUTPUT); 
    pinMode(tmpPin, INPUT_PULLUP); // tenperature sensor pin IN with pull up to bias the diode
    pinMode(batPin, INPUT);
    pinMode(solPin, INPUT);  
    pinMode( audioInPin , INPUT);
    pinMode(chargePin, OUTPUT);
  
  int adcbat = 0;
  int adcsol = 0;
  int adcemi = 0;
  void sendMsg(char*);
  void dash();
  void dot();
  const int in = tmpPin;          //  temperature sensor diode pin
  const int t0 = 20.5;        // temperature calibration point, measure the temperature and write in this constant
  const float vf0 = 567;   // and measure voltage on diode and write in this constant
  // variables
  int i;
  float dtemp, dtemp_avg, tmp, sol, bat, emi;

  ////////////////////////////////////
  // The basic goertzel calculation //
  ////////////////////////////////////
  int  k;
  float omega;
  k = (int) (0.5 + ((n * target_freq) / sampling_freq));
  omega = (2.0 * PI * k) / n;
  sine = sin(omega);
  cosine = cos(omega);
  coeff = 2.0 * cosine;

  ///////////////////////////////
  // define special characters //
  ///////////////////////////////

  Serial.begin(9600);
 
}


///////////////
// main loop //
///////////////
void loop() {

  /////////////////////////////////////
  // The basic where we get the tone //
  /////////////////////////////////////

  //таймер периода маяка (в течении которого идет прием-------------------------
  if (millis() - myTimer1 >= 300000) {   // ждем 300000 миллисек (5 мин) слушая эфир

    // передача маяка
    digitalWrite(chargePin, LOW); // отключаем заряд батареи для измерения напряжений солнечной панели и аккума
    delay(1000); //ждем секунду когда напряжения установятся
    adcbat = analogRead(batPin);  //измеряем
    adcsol = analogRead(solPin);
    //calculating voltages
    bat = (adcbat / 1024.0) * 3.3/*напряжение опоры ацп*/ * 3.06 /*коэффициент делителя(R(bat-adc)+R(adc-ground))/R(adc-ground)*/;
    sol = (adcsol / 1024.0) * 3.3 * 3.06; //ну ты понел


    //если солнечная батарея выдает хоть какое-то напряжение или аккум не разряжен до критического состояния
    //переводим в формат char измеренные напряжения для передачи 
     //if ((bat > 2.8) || (sol > 4.5)) //раскомментируйте эту строку чтобы включить защиту от переразряда аккумулятора, отключена для удобства отладки т.к. она блокирует передачу

    
      char battery [7]; //да, массив из 5 символов требует байт памяти, это фишка этой функции, не пытайтесь сэкономить байты здесь
      dtostrf(bat, 3, 1, battery);
      char solar [7];
      dtostrf(sol, 3, 1, solar);
      dtemp_avg = 0;
      for (i = 0; i < 100; i++)
      {
        float vf = analogRead(tmpPin) * (1100 / 1023.000);
        dtemp = (vf - vf0) * 0.4545454;
        dtemp_avg = dtemp_avg + dtemp;
      }
      tmp = t0 - dtemp_avg / 100;
      char otemp[7];
      dtostrf(tmp, 5, 1, otemp);

      //данные телеметрии собраны, отправляем

      sendMsg("VVV AUTONOMOUS CW ROBOT Q1TA Q1TA LOC 59.86 31.34 SEND Q1TA 558HZ BELOW THIS FREQ FOR COMMANDS LIST "); //beacon call or any text you want to send
      sendMsg("TMP");
      sendMsg(otemp); //temperature
      sendMsg("SOL");
      sendMsg(solar);//solar battery voltage
      sendMsg("BAT");
      sendMsg(battery);//acid voltage


      delay (100); //после нагрузки на батарею ждем какое-то время, чтобы адекватно измерить ее напряжение
           //если напряжение солнечной батареи на 0.5 вольта выше аккума и аккум не достиг полного заряда, включаем заряд
      adcbat = analogRead(batPin);
      adcsol = analogRead(solPin);
      bat = (adcbat  / 1024.0) * 1.1 * 3.06;
      sol = (adcsol / 1024.0) * 1.1 * 3.06;
      if ((bat < 4.56) && (sol > (bat + 0.7))) digitalWrite(chargePin, HIGH);
      else  digitalWrite(chargePin, LOW);
    
    myTimer1 = millis();              // сброс таймера
  }
  // конец логики периодической передачи маяка, начало функции приема морзянки, тут я не понимаю ничерта------------------------------------------------------------------------------

  for (char index = 0; index < n; index++)
  {
    testData[index] = analogRead(audioInPin);
  }
  for (char index = 0; index < n; index++) {
    float Q0;
    Q0 = coeff * Q1 - Q2 + (float) testData[index];
    Q2 = Q1;
    Q1 = Q0;
  }
  float magnitudeSquared = (Q1 * Q1) + (Q2 * Q2) - Q1 * Q2 * coeff; // we do only need the real part //
  magnitude = sqrt(magnitudeSquared);
  Q2 = 0;
  Q1 = 0;

  //Serial.print(magnitude); Serial.println();  //// here you can measure magnitude for setup..

  ///////////////////////////////////////////////////////////
  // here we will try to set the magnitude limit automatic //
  ///////////////////////////////////////////////////////////

  if (magnitude > magnitudelimit_low) {
    magnitudelimit = (magnitudelimit + ((magnitude - magnitudelimit) / 6)); /// moving average filter
  }

  if (magnitudelimit < magnitudelimit_low)
    magnitudelimit = magnitudelimit_low;

  ////////////////////////////////////
  // now we check for the magnitude //
  ////////////////////////////////////

  if (magnitude > magnitudelimit * 0.6) // just to have some space up
    realstate = HIGH;
  else
    realstate = LOW;

  /////////////////////////////////////////////////////
  // here we clean up the state with a noise blanker //
  /////////////////////////////////////////////////////

  if (realstate != realstatebefore) {
    laststarttime = millis();
  }
  if ((millis() - laststarttime) > nbtime) {
    if (realstate != filteredstate) {
      filteredstate = realstate;
    }
  }

  ////////////////////////////////////////////////////////////
  // Then we do want to have some durations on high and low //
  ////////////////////////////////////////////////////////////

  if (filteredstate != filteredstatebefore) {
    if (filteredstate == HIGH) {
      starttimehigh = millis();
      lowduration = (millis() - startttimelow);
    }

    if (filteredstate == LOW) {
      startttimelow = millis();
      highduration = (millis() - starttimehigh);
      if (highduration < (2 * hightimesavg) || hightimesavg == 0) {
        hightimesavg = (highduration + hightimesavg + hightimesavg) / 3; // now we know avg dit time ( rolling 3 avg)
      }
      if (highduration > (5 * hightimesavg) ) {
        hightimesavg = highduration + hightimesavg;   // if speed decrease fast ..
      }
    }
  }

  ///////////////////////////////////////////////////////////////
  // now we will check which kind of baud we have - dit or dah //
  // and what kind of pause we do have 1 - 3 or 7 pause        //
  // we think that hightimeavg = 1 bit                         //
  ///////////////////////////////////////////////////////////////

  if (filteredstate != filteredstatebefore) {
    stop = LOW;
    if (filteredstate == LOW) { //// we did end a HIGH
      if (highduration < (hightimesavg * 2) && highduration > (hightimesavg * 0.6)) { /// 0.6 filter out false dits
        strcat(code, ".");
        Serial.print(".");
      }
      if (highduration > (hightimesavg * 2) && highduration < (hightimesavg * 6)) {
        strcat(code, "-");
        Serial.print("-");
        wpm = (wpm + (1200 / ((highduration) / 3))) / 2; //// the most precise we can do ;o)
      }
    }

    if (filteredstate == HIGH) { //// we did end a LOW

      float lacktime = 1;
      if (wpm > 25)lacktime = 1.0; ///  when high speeds we have to have a little more pause before new letter or new word
      if (wpm > 30)lacktime = 1.2;
      if (wpm > 35)lacktime = 1.5;

      if (lowduration > (hightimesavg * (2 * lacktime)) && lowduration < hightimesavg * (5 * lacktime)) { // letter space
        docode();
        code[0] = '\0';
        Serial.print("/");
      }
      if (lowduration >= hightimesavg * (5 * lacktime)) { // word space
        docode();
        code[0] = '\0';
        Serial.println();
      }
    }
  }

  //////////////////////////////
  // write if no more letters //
  //////////////////////////////

  if ((millis() - startttimelow) > (highduration * 6) && stop == LOW) {
     
   // strData += '\0';
    docode();
    code[0] = '\0';
    parse(); // парсим строку после длинной паузы
    stop = HIGH;
  }

  /////////////////////////////////////
  // we will turn on and off the LED //
  // and the speaker                 //
  /////////////////////////////////////

  if (filteredstate == HIGH) {
    digitalWrite(ledPin, HIGH);
  }
  else {
    digitalWrite(ledPin, LOW);

  }

  //////////////////////////////////
  // the end of main loop clean up//
  /////////////////////////////////
  realstatebefore = realstate;
  lasthighduration = highduration;
  filteredstatebefore = filteredstate;
}


void docode() {
  if (strcmp(code, ".-") == 0) strData += "A";
  if (strcmp(code, "-...") == 0)strData += "B";
  if (strcmp(code, "-.-.") == 0)strData += "C";
  if (strcmp(code, "-..") == 0) strData += "D";
  if (strcmp(code, ".") == 0) strData += "E";
  if (strcmp(code, "..-.") == 0) strData += "F";
  if (strcmp(code, "--.") == 0) strData += "G";
  if (strcmp(code, "....") == 0) strData += "H";
  if (strcmp(code, "..") == 0) strData += "I";
  if (strcmp(code, ".---") == 0) strData += "J";
  if (strcmp(code, "-.-") == 0) strData += "K";
  if (strcmp(code, ".-..") == 0) strData += "L";
  if (strcmp(code, "--") == 0) strData += "M";
  if (strcmp(code, "-.") == 0) strData += "N";
  if (strcmp(code, "---") == 0) strData += "O";
  if (strcmp(code, ".--.") == 0) strData += "P";
  if (strcmp(code, "--.-") == 0) strData += "Q";
  if (strcmp(code, ".-.") == 0) strData += "R";
  if (strcmp(code, "...") == 0) strData += "S";
  if (strcmp(code, "-") == 0) strData += "T";
  if (strcmp(code, "..-") == 0) strData += "U";
  if (strcmp(code, "...-") == 0) strData += "V";
  if (strcmp(code, ".--") == 0) strData += "W";
  if (strcmp(code, "-..-") == 0) strData += "X";
  if (strcmp(code, "-.--") == 0) strData += "Y";
  if (strcmp(code, "--..") == 0) strData += "Z";

 

    if (strcmp(code,".----") == 0) strData += "1";
    if (strcmp(code,"..---") == 0) strData += "2";
    if (strcmp(code,"...--") == 0) strData += "3";
    if (strcmp(code,"....-") == 0) strData += "4";
    if (strcmp(code,".....") == 0) strData += "5";
    if (strcmp(code,"-....") == 0) strData += "6";
    if (strcmp(code,"--...") == 0) strData += "7";
    if (strcmp(code,"---..") == 0) strData += "8";
    if (strcmp(code,"----.") == 0) strData += "9";
    if (strcmp(code,"-----") == 0) strData += "0";
/*
    if (strcmp(code,"..--..") == 0) strData += "A";
    if (strcmp(code,".-.-.-") == 0) strData += "A";
    if (strcmp(code,"--..--") == 0) strData += "A";
    if (strcmp(code,"-.-.--") == 0) strData += "A";
    if (strcmp(code,".--.-.") == 0) strData += "A";
    if (strcmp(code,"---...") == 0) strData += "A";
    if (strcmp(code,"-....-") == 0) strData += "A";
    if (strcmp(code,"-..-.") == 0) strData += "A";

    if (strcmp(code,"-.--.") == 0) strData += "A";
    if (strcmp(code,"-.--.-") == 0) strData += "A";
    if (strcmp(code,".-...") == 0) strData += "A";
    if (strcmp(code,"...-..-") == 0) strData += "A";
    if (strcmp(code,"...-.-") == 0) strData += "A";
    if (strcmp(code,".-.-.") == 0) strData += "A";
    if (strcmp(code,"...-.") == 0) strData += "A";
    //////////////////
    // The specials //
    //////////////////
    if (strcmp(code,".-.-") == 0)strData += "A";
    if (strcmp(code,"---.") == 0) strData += "A";
    if (strcmp(code,".--.-") == 0) strData += "A";
  */

}

  void dash()
  {
    digitalWrite(ledPin, HIGH);
    delay(DASHLEN);
    digitalWrite(ledPin, LOW);
    delay(DOTLEN);
  }


  void dot()
  {
    digitalWrite(ledPin, HIGH) ;
    delay(DOTLEN);
    digitalWrite(ledPin, LOW);
    delay(DOTLEN);
  }


  void sendMsg(char *str)
  {
    int i;

    delay(500);

    for (i = 0; i < strlen(str); i++)
    {
      switch (str[i])
      {
        case 'A':
          dot(); dash(); break;
        case 'B':
          dash(); dot(); dot(); dot(); break;
        case 'C':
          dash(); dot(); dash(); dot(); break;
        case 'D':
          dash(); dot(); dot(); break;
        case 'E':
          dot(); break;
        case 'F':
          dot(); dot(); dash(); dot(); break;
        case 'G':
          dash(); dash(); dot(); break;
        case 'H':
          dot(); dot(); dot(); dot(); break;
        case 'I':
          dot(); dot(); break;
        case 'J':
          dot(); dash(); dash(); dash(); break;
        case 'K':
          dash(); dot(); dash(); break;
        case 'L':
          dot(); dash(); dot(); dot(); break;
        case 'M':
          dash(); dash(); break;
        case 'N':
          dash(); dot(); break;
        case 'O':
          dash(); dash(); dash(); break;
        case 'P':
          dot(); dash(); dash(); dot(); break;
        case 'Q':
          dash(); dash(); dot(); dash(); break;
        case 'R':
          dot(); dash(); dot(); break;
        case 'S':
          dot(); dot(); dot(); break;
        case 'T':
          dash(); break;
        case 'U':
          dot(); dot(); dash(); break;
        case 'V':
          dot(); dot(); dot(); dash(); break;
        case 'W':
          dot(); dash(); dash(); break;
        case 'X':
          dash(); dot(); dot(); dash(); break;
        case 'Y':
          dash(); dot(); dash(); dash(); break;
        case 'Z':
          dash(); dash(); dot(); dot(); break;
        case ' ':
          delay(DOTLEN * 5); break;
        case '.':
          dot(); dash(); dot(); dash(); dot(); dash(); break;
        case ',':
          dash(); dash(); dot(); dot(); dash(); dash(); break;
        case ':':
          dash(); dash(); dash(); dot(); dot(); break;
        case '?':
          dot(); dot(); dash(); dash(); dot(); dot(); break;
        case '\'':
          dot(); dash(); dash(); dash(); dash(); dot(); break;
        case '-':
          dash(); dot(); dot(); dot(); dot(); dash(); break;
        case '/':
          dash(); dot(); dot(); dash(); dot(); break;
        case '(':
        case ')':
          dash(); dot(); dash(); dash(); dot(); dash(); break;
        case '\"':
          dot(); dash(); dot(); dot(); dash(); dot(); break;
        case '@':
          dot(); dash(); dash(); dot(); dash(); dot(); break;
        case '$':
          delay(CARRIER); break;
        case '=':
          dash(); dot(); dot(); dot(); dash(); break;
        case '0':
          dash(); dash(); dash(); dash(); dash(); break;
        case '1':
          dot(); dash(); dash(); dash(); dash(); break;
        case '2':
          dot(); dot(); dash(); dash(); dash(); break;
        case '3':
          dot(); dot(); dot(); dash(); dash(); break;
        case '4':
          dot(); dot(); dot(); dot(); dash(); break;
        case '5':
          dot(); dot(); dot(); dot(); dot(); break;
        case '6':
          dash(); dot(); dot(); dot(); dot(); break;
        case '7':
          dash(); dash(); dot(); dot(); dot(); break;
        case '8':
          dash(); dash(); dash(); dot(); dot(); break;
        case '9':
          dash(); dash(); dash(); dash(); dot(); break;

      }
      delay(2 * DOTLEN);
    }
  }

  void parse() //декодируем принятое и отвечаем на команды

{
  Serial.println(strData);

if (strData == "Q1TA") {Serial.println("quinta"); sendMsg("COMMANDS OWN STAT MUTE");}  //просто сравниваем принятую строку с именем команды которое нам нужно и выполняем нужную нам функцию
if (strData == "OWN") {Serial.println("OWNER"); sendMsg("MADE BY QUINTA");}  
if (strData == "STAT")
{
  Serial.println("STAT");
    digitalWrite(chargePin, LOW); // for proper measuring disconnect solar battery and acid
    delay(1000); //wait some time for stabilising voltages
    adcbat = analogRead(batPin);  //measure voltages in binary
    adcsol = analogRead(solPin);
    //calculating voltages
    bat = (adcbat / 1024.0) * 3.3 * 3.06 ;
    sol = (adcsol / 1024.0) * 3.3 * 3.06; //ну ты понел
//переводим напряжения в строки из float
      char battery [7]; //yes, array length more than 5 symbols that you need, but you need 2 more chars for end of string symbol
      dtostrf(bat, 3, 1, battery);
      char solar [7];
      dtostrf(sol, 3, 1, solar);
      dtemp_avg = 0;
      for (i = 0; i < 100; i++)
      {
        float vf = analogRead(tmpPin) * (1100 / 1023.000);
        dtemp = (vf - vf0) * 0.4545454;
        dtemp_avg = dtemp_avg + dtemp;
      }
      tmp = t0 - dtemp_avg / 100;
      char otemp[7];
      dtostrf(tmp, 5, 1, otemp);

      //собрали и посчитали телеметрию, отправляем
     sendMsg("TMP");
      sendMsg(otemp); //temperature
      sendMsg("SOL");
      sendMsg(solar);//solar battery voltage
      sendMsg("BAT");
      sendMsg(battery);//acid voltage    

Serial.println(otemp);
Serial.println(solar);
Serial.println(battery);
 }
    
    strData = ""; // очищаем строку после декодирования и ответа и принимаем снова
  }
